	org 100h
	cpu 286

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	jc	Crash
;
	mov	bx,1000h
	mov	ah,48h
	int	21h
	jc	Crash

	mov	[DRIVERCALL+2],ax
	mov	ds,ax
	xor	dx,dx
	mov	cx,-1
	mov	bx,10
	mov	ah,3Fh
	int	21h
	jc	Crash
;
	push	cs
	pop	ds
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	mov	bp,ax
	add	bp,bp
	add	bp,ax
	call	@@driver
	mov	b [cs:Playing],1
	jmp	@@exitint
@@stop:
	cmp	b [Playing],1
	jnz	@@bye
	mov	b [Playing],0
	mov	bp,74fh
@@driver:
	mov	[DRIVERCALL],bp
	pushf
	call	far [DRIVERCALL]
@@bye:
	ret
	align 2
DRIVERCALL dd 0
Playing	db 0
	db	13,10,13,10,'Gundam Desert Operation PC98 Driver v1.0 by Mok'
ENDDRIVER:
	end
